Package org.codehaus.groovy.transform

# Class RecordTypeASTTransformation

java.lang.Object
org.codehaus.groovy.transform.AbstractASTTransformation
org.codehaus.groovy.transform.RecordTypeASTTransformation

All Implemented Interfaces:
  `CompilationUnitAware`, `ASTTransformation`, `ErrorCollecting`

public class RecordTypeASTTransformation extends AbstractASTTransformation implements CompilationUnitAware
Handles generation of code for the @RecordType annotation.

- ## Field Summary

  Fields
  Modifier and Type
  Field
  Description
  `static final ClassNode`
  `MY_TYPE`

  ### Fields inherited from class org.codehaus.groovy.transform.AbstractASTTransformation

  `RETENTION_CLASSNODE, sourceUnit`

- ## Constructor Summary

  Constructors
  Constructor
  Description
  `RecordTypeASTTransformation()`

- ## Method Summary

  Modifier and Type
  Method
  Description
  `String`
  `getAnnotationName()`
  If the transform is associated with a single annotation, returns a name suitable for displaying in error messages.
  `static boolean`
  `recordNative(ClassNode node)`
  Indicates that the given classnode is a native JVM record class.
  `void`
  `setCompilationUnit(CompilationUnit unit)`
  `void`
  `visit(ASTNode[] nodes, SourceUnit source)`
  The method is invoked when an AST Transformation is active.

  ### Methods inherited from class org.codehaus.groovy.transform.AbstractASTTransformation

  `addError, checkIncludeExcludeUndefinedAware, checkIncludeExcludeUndefinedAware, checkNotInterface, checkPropertyList, checkPropertyList, checkPropertyList, copyAnnotatedNodeAnnotations, copyAnnotatedNodeAnnotations, deemedInternalName, getMemberClassList, getMemberClassValue, getMemberClassValue, getMemberIntValue, getMemberStringList, getMemberStringValue, getMemberStringValue, getMemberValue, hasAnnotation, init, memberHasValue, shouldSkip, shouldSkip, shouldSkipOnDescriptorUndefinedAware, shouldSkipUndefinedAware, shouldSkipUndefinedAware, tokenize`

  ### Methods inherited from class java.lang.Object

  `clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

- ## Field Details

  - ### MY_TYPE

    public static final ClassNode MY_TYPE

- ## Constructor Details

  - ### RecordTypeASTTransformation

    public RecordTypeASTTransformation()

- ## Method Details

  - ### getAnnotationName

    public String getAnnotationName()
    Description copied from class: `AbstractASTTransformation`
    If the transform is associated with a single annotation, returns a name suitable for displaying in error messages.
    Overrides:
      `getAnnotationName` in class `AbstractASTTransformation`
    Returns:
      The simple name of the annotation including the "@" or null if no such name is defined

  - ### visit

    public void visit(ASTNode[] nodes, SourceUnit source)
    Description copied from interface: `ASTTransformation`
    The method is invoked when an AST Transformation is active. For local transformations, it is invoked once each time the local annotation is encountered. For global transformations, it is invoked once for every source unit, which is typically a source file.
    Specified by:
      `visit` in interface `ASTTransformation`
    Parameters:
      `nodes` - The ASTnodes when the call was triggered. Element 0 is the AnnotationNode that triggered this annotation to be activated. Element 1 is the AnnotatedNode decorated, such as a MethodNode or ClassNode. For global transformations it is usually safe to ignore this parameter.
      `source` - The source unit being compiled. The source unit may contain several classes. For global transformations, information about the AST can be retrieved from this object.

  - ### recordNative

    @Incubating public static boolean recordNative(ClassNode node)
    Indicates that the given classnode is a native JVM record class. For classes being compiled, this will only be valid after the `RecordTypeASTTransformation` transform has been invoked.

  - ### setCompilationUnit

    public void setCompilationUnit(CompilationUnit unit)
    Specified by:
      `setCompilationUnit` in interface `CompilationUnitAware`